using UnityEngine;
using TMPro;

public class GameUIController : MonoBehaviour
{
	[SerializeField]
	private	GameController	gameController;

	[Header("InGame")]
	[SerializeField]
	private	TextMeshProUGUI	textScore;

	[Header("Game Over")]
	[SerializeField]
	private	GameObject		panelGameOver;
	[SerializeField]
	private	TextMeshProUGUI	textResultScore;
	
	[Header("Game Over UI Animation")]
	[SerializeField]
	private	ScaleEffect		effectGameOver;
	[SerializeField]
	private	CountingEffect	effectResultScore;

	private void Update()
	{
		textScore.text = $"SCORE {gameController.Score}";
	}

	public void OnGameOver()
	{
		// GameOver Panel UI Ȱȭ
		panelGameOver.SetActive(true);
		// ȹ  
		textResultScore.text = gameController.Score.ToString();
		// "GAME OVER" ؽƮ ũ  ִϸ̼
		effectGameOver.Play(200, 100);
		// 0 -> gameController.Score  īϴ ִϸ̼
		effectResultScore.Play(0, gameController.Score);
	}

	public void BtnClickGoToLobby()
	{
		Utils.LoadScene(SceneNames.Lobby);
	}
}

